﻿using System;
using System.Threading;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Diagnostics;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Common.Plugins;
using Buddy.Swtor;
using Buddy.Swtor.Objects;
using DefaultCombat.Helpers;
namespace Buddywing.Plugins
{
    class ProximityInteract : IPlugin
    {
        
        #region Implementation of IEquatable<IPlugin>

        /// <summary>

        /// Indicates whether the current object is equal to another object of the same type.

        /// </summary>

        /// <returns>

        /// true if the current object is equal to the <paramref name="other"/> parameter; otherwise, false.

        /// </returns>

        /// <param name="other">An object to compare with this object.</param>

        public bool Equals(IPlugin other)
        {

            return other.Name == Name;

        }

        #endregion

        #region Implementation of IPlugin


        public DateTime LastInteractCheck;
		public ulong LastInteract;

        public string Author { get { return "Bender69"; } }

        public Version Version { get { return new Version(0, 2); } }

        public string Name { get { return "Proximity Interact"; } }

        public string Description { get { return "Use Companion on salvaging nodes or similar"; } }

        public Window DisplayWindow { get { return null; } }        
      
        /// <summary> Executes the pulse action. This is called every "tick" of the bot. </summary>

        public void OnPulse()
        {

            if (DateTime.Now.Subtract(LastInteractCheck).TotalSeconds > 0.5f)
            {
				if (!BuddyTor.Me.IsCasting && !BuddyTor.Me.IsMoving && !BuddyTor.Me.InCombat)
				{
					List<TorNpc> Objects = ObjectManager.GetObjects<TorNpc>().Where(o => o.Distance < 1.0f).ToList();
					foreach (TorNpc t in Objects)
					{
						if (t.IsDead && !t.IsLootable && LastInteract != t.Guid)
						{
                            DefaultCombat.Helpers.CombatHotkeys.PauseRotation = true;
							LastInteract = t.Guid;
							Logging.Write("[ProximityInteract] " + t.Name + " id:" + t.Guid);
							t.Interact();
							t.Interact();
						}
                    }
                    DefaultCombat.Helpers.CombatHotkeys.PauseRotation = false;
                }

                LastInteractCheck = DateTime.Now;      
            }
           
        }

        

        /// <summary> Executes the initialize action. This is called at initial bot startup. (When the bot itself is started, not when Start() is called) </summary>
        public void OnInitialize()
        {            
           
        }


        public void OnStart()
        {
            LastInteractCheck = DateTime.Now;            
        }

        public void OnStop()
        {
            
        }

        /// <summary> Executes the shutdown action. This is called when the bot is shutting down. (Not when Stop() is called) </summary>

        public void OnShutdown()
        {

        }

        /// <summary> Executes the enabled action. This is called when the user has enabled this specific plugin via the GUI. </summary>

        public void OnEnabled()
        {
             
        }


        /// <summary> Executes the disabled action. This is called whent he user has disabled this specific plugin via the GUI. </summary>

        public void OnDisabled()
        {
            
        }     

        #endregion


    }
}
